// --- [ SLA_main.c ] ---------------------------------------------------------
//
//       Testprogramm fr den TWI-Slave
//       hier zum Testen der Funktion TWI_SLA_Set_TxPtr()
//       tab = 3 - 22.02.2012

#include <avr/interrupt.h>
#include <avr/io.h>
#include <inttypes.h>
#include "TWI_Slave.h"

// ----------------------------------------------------------------------------
int main( void )
	{
   uint8_t test_array1[] = { 100, 101, 102, 103, 104, 105, 106, 107, 108, 109};
   uint8_t test_array2[] = { 200, 201, 202, 203, 204, 205, 206, 207, 208, 209};

	uint8_t twi_buffer[16];
	uint8_t j, i, z = 0;

	asm volatile ("sei");

	TWI_SLA_Init();                           // Den Slave empfangsbereit machen

   while (1)
   {
      if ((i = TWI_SLA_Rx_Cnt()))            // wenn Daten eingegangen sind, dann ist i > 0
      {
                                             // es mssen die Daten in jedem Fall abgeholt werden
                                             // denn dabei wird der TWI-Empfang wieder aktiviert !!
                                             //
         if (i == 1)                         // Sonderfall - Nur die Adresse wurde empfangen, keine Daten
                                             // hier wird die bergabe des Pointers an das TWI-Modul getestet
         {
            TWI_SLA_Get_Data(twi_buffer);    // Die Daten in jedem Fall abholen
                                             // wenn nicht, dann bockt das TWI-Modul (der TWI-Interrupt ist disabled)

            if (z == 0)                      // hier ein Test - es wird abwechselnd aus einem der beiden Arrays gelesen
            {
               z = 1;
               TWI_SLA_Set_TxPtr(test_array1);
            }
            else
            {
               z = 0;
               TWI_SLA_Set_TxPtr(test_array2);
            }
         }

         else                                // i > 1
         {

            TWI_SLA_Get_Data(twi_buffer);    // die Daten abholen

            /*
            tu was mit twi_buffer
            */

            // hier wird zur Demonstation zum gesendeten Byte jeweils 2 addiert !
            for (j = 0; j < i; j++) twi_buffer[j] += 2; // jedes Byte incrementieren
            TWI_SLA_Put_Data(twi_buffer, i);      // und wieder in den Sendepuffer stellen

            // wenn man nun lesend auf den Slave zugreift, sollte man die gendeten Daten sehen
         }
      }
   }
}

// --- [ eof ] ----------------------------------------------------------------


